JavaScript 例外処理のサンプル(try…catchとthrow)

JavaScriptの例外処理のサンプルです。
try...catch構文とthrow文についてです。

目次

try...catch構文

try {
   実行される処理
} catch ( 変数 ) {
   実行される処理
} finally {
  実行される処理
}
  • tryの箇所で例外が発生した場合、catchで例外を捕まえます。
  • 全体の処理が落ちることを防ぎます。
  • catchの変数はErrorオブジェクトを受け取ります
  • finallyは例外があってもなくても実行されます。
  • finallyは省略可能です。
  • 以下はMDNのtry...catch構文のリンクです。
    https://developer.mozilla.org/ja/docs/Web/JavaScript/Reference/Statements/try...catch

コード

try...catchのサンプルのコードです。
3行目は定義されていないaを計算式で使用しているのでエラーが発生します。
4行目でcatchします。
5行目は、e.messageでエラー内容を表示します。
7行目のfinallyも実行されます。

<script>
	try{
		var b =  100 * a;
	}catch(e){
		document.writeln(e.message,"<br />");
		// 出力結果: a is not defined
	}finally{
		document.writeln("finallyです"); // 出力結果: finallyです
	}
</script>

throw文

throw new Error (文言)

コード

throw文のサンプルのコードです。
5行目は、throw文でユーザー定義の例外を作成しています。
7行目でユーザー定義の例外をcatchします。

<script>
	var a = 1;
	try{
		if(a == 1){
			throw new Error('1以外を入力して下さい');
		}
	}catch(e){
		document.writeln(e.message,"<br />");
		// 出力結果: 1以外を入力して下さい
	}finally{
		document.writeln("finallyです"); // 出力結果: finallyです
	}
</script>

関連の記事

JavaScript 無名関数と即時関数のサンプル
JavaScript クロージャのサンプル
JavaScript 高階関数のサンプル
JavaScript エスケープシーケンスのサンプル
JavaScript 変数の巻き上げのサンプル



△上に戻る